// ==UserScript==
// @name           Facebook Video
// @namespace      sizzlemctwizzle
// @description    Adds links to download or convert videos with Zamzar.com, and provides code to embed videos in other sites.
// @version        2.2.2
// @include        http://*.facebook.com/*
// ==/UserScript==

// Copyleft Michael Medley <medleymind@gmail.com>, All Wrongs Reserved
function get_values(swfid) {
  // Get the Video url
  values = new Array();
  if (unsafeWindow[swfid].getVariable('highqual_src')) { // Get High Quality if available
    src = unsafeWindow[swfid].getVariable('highqual_src');
    unsafeWindow[swfid].addVariable("video_src", unsafeWindow[swfid].getVariable('highqual_src'));
  } else { // Default to Low Quality if unavailable
    src = unsafeWindow[swfid].getVariable('video_src');
  }
  values[0] = decodeURIComponent(src);
  values[1] = "http://www.zamzar.com/url/?u=" + src;
  return values;
}

function addGlobalStyle(css) {
  var head, style;
  head = document.getElementsByTagName('head')[0];
  if (!head) { return; }
  style = document.createElement('style');
  style.type = 'text/css';
  style.innerHTML = css;
  head.appendChild(style);
}

function $(element) { return document.getElementById(element); }
function insertAfter(node, after) { after.parentNode.insertBefore(node, after.nextSibling);}

// Get the abosolute url of the current page
function current_url() {
  if (window.location.hash.match(/\.php/)) {
      return 'http://'+window.location.host+window.location.hash.split('#')[1];
  } else if (window.location.href.indexOf('#') != -1) {
      return window.location.hash.split('#')[0];
  } else {
    return window.location.href;
  }
}

// Get the Emebd Code using Ajax
function get_code(swfid, callback) {
  if (!code[swfid]) {
    var xmlhttp =  new XMLHttpRequest();
    xmlhttp.open("POST", "http://www.facebook.com/ajax/video/embed.php", true);
    var params = "vid="+unsafeWindow[swfid].getVariable('video_id')+"&post_form_id="+$('post_form_id').value+"&post_form_id_source=AsyncRequest&nectar_impid="+unsafeWindow.env_get("nectar_last_impression_id");
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    xmlhttp.setRequestHeader("Content-length", params.length);
    xmlhttp.setRequestHeader("Connection", "close");
    xmlhttp.onreadystatechange = function() {
      if (xmlhttp.readyState==4 && xmlhttp.status==200) {
	ajax_code = eval('('+xmlhttp.responseText.split('for (;;);')[1]+')').payload.body;
	code[swfid] = ajax_code.split('value="')[1].split('"')[0].replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"');
	width[swfid] = /width="(.*?)"/.exec(code[swfid])[1];
	height[swfid] = /height="(.*?)"/.exec(code[swfid])[1];
	callback();
      }
    }
    xmlhttp.send(params);
  } else {
    callback();
  }
}

// Add elements to a video page
function add_elements(swfid, values) {

  if (embed = document.evaluate('//a[contains(@onclick, "motion_show_embed_video_dialog")]', document, null,  9, null).singleNodeValue) embed.style.display = "none";

  // Embed Code
  link = document.createElement('a');
  link.href = "#";
  link.appendChild(document.createTextNode("Embed this Video"));
  link.addEventListener('click',function (e) {show_code(swfid); e.preventDefault();},false);
  li = document.createElement('li');
  li.appendChild(link);

  // Wizard link
  link = document.createElement('a');
  link.href = "#";
  link.appendChild(document.createTextNode("Customize Code"));
  li2 = document.createElement('li');
  li2.appendChild(link);
  link.addEventListener('click',function (e) {run_wizard(swfid);e.preventDefault();},false);

  // Download Flv Link
  link = document.createElement('a');
  link.href = values[0];
  link.id = "download_" + swfid;
  link.appendChild(document.createTextNode("Download Video"));
  li3 = document.createElement('li');
  li3.appendChild(link);

  // Convert Link
  link = document.createElement('a');
  link.href = values[1];
  link.id = "convert_" + swfid;
  link.appendChild(document.createTextNode("Convert Video"));
  li4 = document.createElement('li');
  li4.appendChild(link);

  // Public Links
  pubdiv = document.createElement('div');
  pubdiv.id = "public_link_photo";
  pubdiv.appendChild(document.createTextNode("Show people this video by sending them this public link: "));
  pubdiv.appendChild(document.createElement('span').appendChild(document.createTextNode(current_url())));

  // Append Elements
  ($('main_column')) ? insertAfter(pubdiv, $('main_column').parentNode) : void(0);
  var ul = document.evaluate('//ul[@class="actionspro"]', document, null, 9, null).singleNodeValue;
  ul.appendChild(li);
  ul.appendChild(li2);
  ul.appendChild(li3);
  ul.appendChild(li4);
}

// Run the script if video posted on site besides a video page: feeds, walls, and messages
function posted_videos(swfid, values) {
  actions = document.getElementById("actions_"+swfid);
  actions.innerHTML = '<a href="' + values[0] + '" id="download_' + swfid + '">Download Video</a> | <a href="' + values[1] + '" id="convert_' + swfid + '">Convert Video</a> | <a href="#" id="embed_' + swfid + '">Embed this Video</a> | <a href="#" id="wizard_' + swfid +'">Customize Code</a>';
  actions.setAttribute('class', 'fb_vid_actions');
  // Embed Code
  $('embed_'+swfid).addEventListener('click',function (e) {show_code(swfid); e.preventDefault();},false);
  // Wizard link
  $('wizard_'+swfid).addEventListener('click',function (e) {run_wizard(swfid); e.preventDefault();},false);

}

function show_code(swfid) {
  get_code(swfid, function() {
  $('independent').style.display = 'block';
  $('independent').innerHTML = '<div style="top: 125px;" class="generic_dialog_popup"><table style="width: 487px;" id="pop_dialog_table" class="pop_dialog_table"><tbody><tr><td class="pop_topleft"></td><td class="pop_border pop_top"></td><td class="pop_topright"></td></tr><tr><td class="pop_border pop_side"></td><td class="pop_content" id="pop_content"><h2 class="dialog_title"><span>Embed this video</span></h2><div class="dialog_content"><div class="dialog_body"><div class="embed_description">You can use this code to display this video on any site on the web.The video will respect Facebook privacy settings.</div><br><div>Embed code:<input size="40" class="code_block" onclick="this.focus(); this.select();" id="" name="" value=\''+code[swfid]+'\' type="text"></div></div><div class="dialog_buttons"><input class="inputsubmit" name="ok" value="Okay" onclick="document.getElementById(\'independent\').style.display = \'none\';" type="button"></div></div></td><td class="pop_border pop_side"></td></tr><tr><td class="pop_bottomleft"></td><td class="pop_border pop_bottom"></td><td class="pop_bottomright"></td></tr></tbody></table></div>';
    });
}

function run_wizard(swfid) {
  get_code(swfid, function() {
  // Embed Wizard
  $('independent').style.display = 'block';
  wizard_html = '<div style="top: 125px;" class="generic_dialog_popup"><table style="width: 487px;" id="pop_dialog_table" class="pop_dialog_table"><tbody><tr><td class="pop_topleft"></td><td class="pop_border pop_top"></td><td class="pop_topright"></td></tr><tr><td class="pop_border pop_side"></td><td class="pop_content" id="pop_content"><h2 class="dialog_title"><span>Customize Embed Code</span></h2><div id="embed_options" style="padding:20px;"><p>'+
'<form id="custom_'+swfid+'"><table><tr><td><label>Width</lable></td><td><input type="text" id="width_'+swfid+'" class="code_block" size="15" value="'+width[swfid]+'" /></td></tr>'+
    '<tr><td><label>Height</lable></td><td><input type="text" id="height_'+swfid+'" class="code_block" size="15" value="'+height[swfid]+'" /></td></tr></table></form></p></div>\n'+
  '<div class="dialog_buttons"><input class="inputsubmit" value="Update" id="update_'+swfid+'" type="button" onclick="document.getElementById(\'independent\').style.display = \'none\';" /></div></td><td class="pop_border pop_side"></td></tr><tr><td class="pop_bottomleft"></td><td class="pop_border pop_bottom"></td><td class="pop_bottomright"></td></tr></tbody></table></div>';
  $('independent').innerHTML = wizard_html;

 $("width_"+swfid).addEventListener('blur',function () {
    $("height_"+swfid).value = Math.round(($("width_"+swfid).value/width[swfid])*height[swfid]);
   },false);

  $("height_"+swfid).addEventListener('blur',function () {
    $("width_"+swfid).value = Math.round(($("height_"+swfid).value/height[swfid])*width[swfid]);
    },false);

  $("update_"+swfid).addEventListener('click',function () {
      update_video(swfid);
    },false);
   });
}

// Show the effect of the video customizer in the page
function update_video(swfid) {
  new_width = $("width_"+swfid).value;
  new_height = $("height_"+swfid).value;
  code[swfid] = code[swfid].replace(new RegExp('width="'+width[swfid]+'"', 'g'), 'width="'+new_width+'"').replace(new RegExp('height="'+height[swfid]+'"', 'g'), 'height="'+new_height+'"');
  width[swfid] = new_width;
  height[swfid] = new_height;
  $(swfid+"_holder").innerHTML = code[swfid];
}

// Locate Videos
function find_videos() {
  document.body.removeEventListener('DOMNodeInserted', find_videos, false);
  var videos = document.evaluate('//div[@class="fb_video_holder"] | //div[@class="mvp_holder"]', document, null, 6, null), video, i=videos.snapshotLength;
  while (video=videos.snapshotItem(--i)) {
    if (!video.getAttribute('mod')) {
      // Is it a holder or an embed object?
      if (video.className == "fb_video_holder") {
	swfid = video.getAttribute('id').split('_holder')[0];
      } else if (video.getElementsByTagName('embed')[0]) {
	swfid = video.getElementsByTagName('embed')[0].getAttribute('id');
	video.setAttribute('id', swfid+"_holder");
      }
      if (current_url().match('/video/') == null) { // Posted Video
	div = document.createElement('div');
        div.setAttribute('id', "actions_"+swfid);
	video.parentNode.parentNode.insertBefore(div, video.parentNode.nextSibling);
	if (unsafeWindow[swfid]) posted_videos(swfid, get_values(swfid));
      } else if ($("video_actions")) { // Video Page
	$("video_actions").setAttribute('id', "actions_"+swfid);
	if (unsafeWindow[swfid]) add_elements(swfid, get_values(swfid));
      }
      video.setAttribute('mod', "done");
    } // Modifications have already been made
  }
}

// Style I stole from Facebook
style = '\n.code_block {\n'+
'font-size:12px;\n' +
'background:#f7f7f7;\n' +
'width: 190px;\n' +
'border:1px solid #ccc;\n' +
'color:#555;\n' +
'}\n\n' +
'#public_link_photo {\n' +
'clear: both;\n' +
'color: #333;\n' +
'font-size: 9px;\n' +
'padding: 5px 5px;\n' +
'text-align: center;\n' +
'margin: 10px 0px 0px 0px;\n' +
'background: #f7f7f7;\n' +
'border-top: 1px solid #D8DFEA;\n' +
'}\n\n' +
'#public_link_photo span {\n' +
'color: black;\n' +
'display: block;\n' +
'font-size: 11px;\n' +
'}\n' +
'.fb_vid_actions { background-color: rgb(236, 239, 245);\n' +
'padding: 5px;\n' +
'text-align: center;\n' +
'display:block;\n' +
'float:none;\n' +
'margin-top: 10px;\n' +
'}\n' +
'#independent { display:none;\n' +
'z-index:10000;\n' +
'position: fixed;\n' +
'}\n\n';

// This is triggered by Facebook whenever the page changes
function watchforchange() {
  document.documentElement.removeEventListener('DOMNodeInserted', watchforchange, false);
  setTimeout(function () {
      if ( document.evaluate('//div[@mod]', document, null, 6, null).snapshotLength < 1) {
	$('independent').style.display = 'none';
      }
      find_videos(); 
      document.documentElement.addEventListener('DOMNodeInserted', watchforchange, false); 
    }, 500);
}

// Wait for the body element to exist
var checker=setInterval(function(){
    if(document.body) {
      clearInterval(checker);
      var ourpopup = document.createElement('div');
      ourpopup.id = 'independent';
      ourpopup.className = 'generic_dialog video_embed_dialog pop_dialog';
      addGlobalStyle(style);
      document.body.appendChild(ourpopup);
      code = {};
      width = {};
      height = {};
      watchforchange();
    }
  },200);